
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>深入理解Java的接口和抽象类 / iVAN</title>

    <meta name="description" content="深入理解Java的接口和抽象类 对于面向对象编程来说,抽象是它的一大特征之一.在Java中,可以通过两种形式来体现OOP的抽象:接口和抽象类.这两者有太多相似的地方,又有太多不同的地方.很多人在初学的时候会以为它们可以随意互换使用,但是实际则不然.今天我们就一起来学习一下Java中的接口和抽象类.下面是本文的目录大纲: 一.抽象类 二.接口 三.抽象类和接口的区别 若有不正之处,请多多谅解并欢迎批评指正,不甚感激. 一.抽象类 在了解抽象类之前,先来了解一下抽象方法.抽象方法是一种特殊的方法:它只有声明,而没有具体的实现.抽象">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">深入理解Java的接口和抽象类</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>对于面向对象编程来说，抽象是它的一大特征之一。在Java中，可以通过两种形式来体现OOP的抽象：接口和抽象类。这两者有太多相似的地方，又有太多不同的地方。很多人在初学的时候会以为它们可以随意互换使用，但是实际则不然。今天我们就一起来学习一下Java中的接口和抽象类。下面是本文的目录大纲：</p>
<p>　　一.抽象类</p>
<p>　　二.接口</p>
<p>　　三.抽象类和接口的区别</p>
<p>　　若有不正之处，请多多谅解并欢迎批评指正，不甚感激。</p>
<p>一.抽象类</p>
<p>　　在了解抽象类之前，先来了解一下抽象方法。抽象方法是一种特殊的方法：它只有声明，而没有具体的实现。抽象方法的声明格式为：</p>
<pre><code>abstract void fun();</code></pre>
<p>抽象方法必须用abstract关键字进行修饰。如果一个类含有抽象方法，则称这个类为抽象类，抽象类必须在类前用abstract关键字修饰。因为抽象类中含有无具体实现的方法，所以不能用抽象类创建对象。</p>
<p>　　下面要注意一个问题：在《JAVA编程思想》一书中，将抽象类定义为“包含抽象方法的类”，但是后面发现如果一个类不包含抽象方法，只是用abstract修饰的话也是抽象类。也就是说抽象类不一定必须含有抽象方法。个人觉得这个属于钻牛角尖的问题吧，因为如果一个抽象类不包含任何抽象方法，为何还要设计为抽象类？所以暂且记住这个概念吧，不必去深究为什么。如果你想学习Java可以来这个群，首先是二二零，中间是一四二，最后是九零六，里面有大量的学习资料可以下载。</p>
<pre><code>[public] abstract class ClassName {
    abstract void fun();
}</code></pre>
<p>从这里可以看出，抽象类就是为了继承而存在的，如果你定义了一个抽象类，却不去继承它，那么等于白白创建了这个抽象类，因为你不能用它来做任何事情。对于一个父类，如果它的某个方法在父类中实现出来没有任何意义，必须根据子类的实际需求来进行不同的实现，那么就可以将这个方法声明为abstract方法，此时这个类也就成为abstract类了。</p>
<p>　　包含抽象方法的类称为抽象类，但并不意味着抽象类中只能有抽象方法，它和普通类一样，同样可以拥有成员变量和普通的成员方法。注意，抽象类和普通类的主要有三点区别：</p>
<p>　　1）抽象方法必须为public或者protected（因为如果为private，则不能被子类继承，子类便无法实现该方法），缺省情况下默认为public。</p>
<p>　　2）抽象类不能用来创建对象；</p>
<p>　　3）如果一个类继承于一个抽象类，则子类必须实现父类的抽象方法。如果子类没有实现父类的抽象方法，则必须将子类也定义为为abstract类。</p>
<p>　　在其他方面，抽象类和普通的类并没有区别。</p>
<p>二.接口</p>
<p>　　接口，英文称作interface，在软件工程中，接口泛指供别人调用的方法或者函数。从这里，我们可以体会到Java语言设计者的初衷，它是对行为的抽象。在Java中，定一个接口的形式如下：</p>
<pre><code>[public] interface InterfaceName {

}</code></pre>
<p>接口中可以含有 变量和方法。但是要注意，接口中的变量会被隐式地指定为public static final变量（并且只能是public static final变量，用private修饰会报编译错误），而方法会被隐式地指定为public abstract方法且只能是public abstract方法（用其他关键字，比如private、protected、static、 final等修饰会报编译错误），并且接口中所有的方法不能有具体的实现，也就是说，接口中的方法必须都是抽象方法。从这里可以隐约看出接口和抽象类的区别，接口是一种极度抽象的类型，它比抽象类更加“抽象”，并且一般情况下不在接口中定义变量。</p>
<p>　　要让一个类遵循某组特地的接口需要使用implements关键字，具体格式如下：</p>
<pre><code>class ClassName implements Interface1,Interface2,[....]{
}</code></pre>
<p>可以看出，允许一个类遵循多个特定的接口。如果一个非抽象类遵循了某个接口，就必须实现该接口中的所有方法。对于遵循某个接口的抽象类，可以不实现该接口中的抽象方法。</p>
<p>三.抽象类和接口的区别</p>
<p>1.语法层面上的区别</p>
<p>　　1）抽象类可以提供成员方法的实现细节，而接口中只能存在public abstract 方法；</p>
<p>　　2）抽象类中的成员变量可以是各种类型的，而接口中的成员变量只能是public static final类型的；</p>
<p>　　3）接口中不能含有静态代码块以及静态方法，而抽象类可以有静态代码块和静态方法；</p>
<p>　　4）一个类只能继承一个抽象类，而一个类却可以实现多个接口。</p>
<p>2.设计层面上的区别</p>
<p>　　1）抽象类是对一种事物的抽象，即对类抽象，而接口是对行为的抽象。抽象类是对整个类整体进行抽象，包括属性、行为，但是接口却是对类局部（行为）进行抽象。举个简单的例子，飞机和鸟是不同类的事物，但是它们都有一个共性，就是都会飞。那么在设计的时候，可以将飞机设计为一个类Airplane，将鸟设计为一个类Bird，但是不能将 飞行 这个特性也设计为类，因此它只是一个行为特性，并不是对一类事物的抽象描述。此时可以将 飞行 设计为一个接口Fly，包含方法fly( )，然后Airplane和Bird分别根据自己的需要实现Fly这个接口。然后至于有不同种类的飞机，比如战斗机、民用飞机等直接继承Airplane即可，对于鸟也是类似的，不同种类的鸟直接继承Bird类即可。从这里可以看出，继承是一个 “是不是”的关系，而 接口 实现则是 “有没有”的关系。如果一个类继承了某个抽象类，则子类必定是抽象类的种类，而接口实现则是有没有、具备不具备的关系，比如鸟是否能飞（或者是否具备飞行这个特点），能飞行则可以实现这个接口，不能飞行就不实现这个接口。</p>
<p>　　2）设计层面不同，抽象类作为很多子类的父类，它是一种模板式设计。而接口是一种行为规范，它是一种辐射式设计。什么是模板式设计？最简单例子，大家都用过ppt里面的模板，如果用模板A设计了ppt B和ppt C，ppt B和ppt C公共的部分就是模板A了，如果它们的公共部分需要改动，则只需要改动模板A就可以了，不需要重新对ppt B和ppt C进行改动。而辐射式设计，比如某个电梯都装了某种报警器，一旦要更新报警器，就必须全部更新。也就是说对于抽象类，如果需要添加新的方法，可以直接在抽象类中添加具体的实现，子类可以不进行变更；而对于接口则不行，如果接口进行了变更，则所有实现这个接口的类都必须进行相应的改动。</p>
<p>　　下面看一个网上流传最广泛的例子：门和警报的例子：门都有open( )和close( )两个动作，此时我们可以定义通过抽象类和接口来定义这个抽象概念：</p>
<pre><code>abstract class Door {
    public abstract void open();
    public abstract void close();
}</code></pre>
<p>　或者：</p>
<pre><code>interface Door {
    public abstract void open();
    public abstract void close();
}</code></pre>
<p>但是现在如果我们需要门具有报警alarm( )的功能，那么该如何实现？下面提供两种思路：</p>
<p>　　1）将这三个功能都放在抽象类里面，但是这样一来所有继承于这个抽象类的子类都具备了报警功能，但是有的门并不一定具备报警功能；</p>
<p>　　2）将这三个功能都放在接口里面，需要用到报警功能的类就需要实现这个接口中的open( )和close( )，也许这个类根本就不具备open( )和close( )这两个功能，比如火灾报警器。</p>
<p>　　从这里可以看出， Door的open() 、close()和alarm()根本就属于两个不同范畴内的行为，open()和close()属于门本身固有的行为特性，而alarm()属于延伸的附加行为。因此最好的解决办法是单独将报警设计为一个接口，包含alarm()行为,Door设计为单独的一个抽象类，包含open和close两种行为。再设计一个报警门继承Door类和实现Alarm接口。</p>
<pre><code>interface Alram {
    void alarm();
}

abstract class Door {
    void open();
    void close();
}

class AlarmDoor extends Door implements Alarm {
    void oepn() {
      //....
    }
    void close() {
      //....
    }
    void alarm() {
      //....
    }
}</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-17 05:25:52</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%a0%96%e7%a4%be%e5%8c%ba/" title="云栖社区">云栖社区</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/open/" title="open">open</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>深入理解Java的接口和抽象类的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL5Q40z.html" rel="bookmark">深入理解Java的接口与抽象类&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于面向对象编程来说,抽象是它的一大特征之一.在Java中,可以通过两种形式来体现OOP的抽象:接口和抽象类.这两者有太多相似的地方,又有太多不同的地方.很多人在初学的时候会以为它们可以随意互换使用,但是实际则不然.今天我们就一起来学习一下Java中的接口和抽象类.下面是本文的目录大纲: 一.抽象类 二.接口 三.抽象类和接口的区别 一.抽象类 在了解抽象类之前,先来了解一下抽象方法.抽象方法是一种特殊的方法:它只有声明,而没有具体的实现.抽象方法的声明格式为:    abstract void			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPNqJ0b.html" rel="bookmark">Java中接口和抽象类的区别与相同之处</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了Java中接口和抽象类的区别与相同之处,本文讲解了抽象类的概念.接口的概念.接口和抽象类的区别与联系等内容,需要的朋友可以参考下 1. 抽象类: (1).概念:抽象类是对一种事物的抽象,即对类抽..抽象类是对整个类整体进行抽象,包括属性.行为.Java抽象类和Java接口一样,都用来声明一个新的类型.并且作为一个类型的等级结构的起点. (2).格式: 代码如下: public abstract class abstractDemo{ /**属性*/ private Stri			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlVZvVz.html" rel="bookmark">Java中接口和抽象类的区别与相同之处&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 抽象类: (1).概念:抽象类是对一种事物的抽象,即对类抽..抽象类是对整个类整体进行抽象,包括属性.行为.Java抽象类和Java接口一样,都用来声明一个新的类型.并且作为一个类型的等级结构的起点. (2).格式: 复制代码 代码如下:    public abstract class abstractDemo{             /**属性*/             private String name;             /**方法*/             pub			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAwKVQz.html" rel="bookmark">选择Java接口还是抽象类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				选择Java接口还是抽象类 作者:俞良松 本文选自:开放系统世界-赛迪网 2003年03月12日 很多人有过这样的疑问:为什么有的地方必须使用接口而不是抽象类,而在另一些地方,又必须使用抽象类而不是接口呢?或者说,在考虑Java类的一般化问题时,很多人会在接口和抽象类之间犹豫不决,甚至随便选择一种. 实际上接口和抽象类的选择不是随心所欲的. 要理解接口和抽象类的选择原则,有两个概念很重要:对象的行为和对象的实现.如果一个实体可以有多种实现方式,则在设计实体行为的描述方式时,应当达到这样一个目标:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zenkOb.html" rel="bookmark">Java接口和抽象类实例分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  本文实例讲述了Java的接口和抽象类.分享给大家供大家参考.具体分析如下: 对于面向对象编程来说,抽象是它的一大特征之一.在Java中,可以通过两种形式来体现OOP的抽象:接口和抽象类.这两者有太多相似的地方,又有太多不同的地方.很多人在初学的时候会以为它们可以随意互换使用,但是实际则不然.今天我们就一起来学习一下Java中的接口和抽象类. 若有不正之处,请多多谅解并欢迎批评指正,不甚感激. 一.抽象类 在了解抽象类之前,先来了解一下抽象方法.抽象方法是一种特殊的方法:它只有声明,而没有具体			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOkkXmz.html" rel="bookmark">Java接口和抽象类实例分析&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Java的接口和抽象类.分享给大家供大家参考.具体分析如下: 对于面向对象编程来说,抽象是它的一大特征之一.在Java中,可以通过两种形式来体现OOP的抽象:接口和抽象类.这两者有太多相似的地方,又有太多不同的地方.很多人在初学的时候会以为它们可以随意互换使用,但是实际则不然.今天我们就一起来学习一下Java中的接口和抽象类. 若有不正之处,请多多谅解并欢迎批评指正,不甚感激. 一.抽象类 在了解抽象类之前,先来了解一下抽象方法.抽象方法是一种特殊的方法:它只有声明,而没有具体的实			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE8dQ9z.html" rel="bookmark">我是如何理解Java抽象类和接口的</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在面试中我们经常被问到:Java中抽象类和接口的区别是什么?然后,我们就大说一通抽象类可以有方法,接口不能有实际的方法啦;一个类只能继承一个抽象类,却可以继承多个接口啦,balabala一大堆,就好像把标准答案熟练的说出来一样. 抽象类和接口这篇文章讲到了他们的区别和联系,它们确实有很多相似的地方,但是从本质上看,或从语言的设计角度来看,这不是它们最本质的区别. 不卖关子,我个人对这两个的理解: 类是具体实例的抽象,比如一个json字符串的抽象;而抽象类就是类的抽象;接口就是抽象类的抽象,接口更			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3JVkWz.html" rel="bookmark">Java千百问&lowbar;05面向对象（005）&lowbar;接口和抽象类有什么区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.接口和抽象类有什么区别 在Java语言中,抽象类abstract class和接口interface是抽象定义的两种机制. 正是由于这两种机制的存在,才赋予了Java强大的面向对象能力.抽象类abstract class和接口interface在对于抽象定义方面具有很大的相似性,甚至可以相互替换.因此很多开发者在进行抽象定义时对二者的选择显得比较随意.其实,两者之间还是有很大的区别,对于它们的选择能反映出对问题本质的理解.对设计意图的理解. 了解抽象类看这里:java中抽象概念如何体现的 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn86eAb.html" rel="bookmark">Java接口和抽象类用法实例总结&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Java接口和抽象类用法.分享给大家供大家参考,具体如下: 接口 1 因为java不支持多重继承,所以有了接口,一个类只能继承一个父类,但可以实现多个接口,接口本身也可以继承多个接口. 2 接口里面的成员变量默认都是public static final类型的.必须被显示的初始化. 3 接口里面的方法默认都是public abstract类型的.隐式声明. 4 接口没有构造方法,不能被实例化. 5 接口不能实现另一个接口,但可以继承多个接口. 6 类如果实现了一个接口,那么必须实现			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjmE0z.html" rel="bookmark" class="title">uiview-使用图形图片设置UIView缩略图</a>
					<div>
						问题描述 使用图形图片设置UIView缩略图 对一个UIView动画用图形context做了预览图片处理. 等到释放这个数组或者图片不需要再预览时,应该怎么释放内存? 用_pictureArray = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkAy5b.html" rel="bookmark" class="title">使用Londiste3 增量同步 线下PostgreSQL 到 阿里云RDS PG</a>
					<div>
						源端 CentOS 7 PostgreSQL 9.5.2 , listen port 1922 公网IP 101.xxx.xxx.171 skytools 3.2.6 目标端 RDS PG xxx.d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQKD8p.html" rel="bookmark" class="title">实例讲解Apache&plus;tomcat&plus;ssl配置</a>
					<div>
						apache     我的运行环境:Windows2003 Server SP4 + J2SDK1.5.0 + Apache2.0.54 + Tomcat5.5.9     **准备软件:    1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeWBNM.html" rel="bookmark" class="title">键盘和鼠标事件测试</a>
					<div>
						&lt;HTML&gt; &lt;HEAD&gt; &lt;TITLE&gt;键盘和鼠标事件测试&lt;/TITLE&gt; &lt;script language=&quot;javascript& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlPROM.html" rel="bookmark" class="title">Jmail的属性和方法</a>
					<div>
						属性:Body : String(v3.0) E-Mail的主体JMail.Body = &quot;Hello world&quot; Charset : String(v3.0) 设定邮件的字符集 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7XeEb.html" rel="bookmark" class="title">博弈树，动态规划（计算好的子问题存储起来，以后直接取用）</a>
					<div>
						public class GameTree { /** * 判断剩余球数,谁能取到最后谁赢, * ,一人取一次,默认我方先取,,能否必胜,能就返回true,否则false * @param x剩余球数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NEZ7z.html" rel="bookmark" class="title">C语言学习教程第九章-预处理&lpar;1&rpar;</a>
					<div>
						预处理 概述在前面各章中,已多次使用过以&quot;#&quot;号开头的预处理命令.如包含命令# include,宏定义命令# define等.在源程序中这些命令都放在函数之外, 而且一般都放在源文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6JRXz.html" rel="bookmark" class="title">安装SQL Server 2008 R2和Visual Studio 2010时的1406错误解决</a>
					<div>
						问题描述:重新安装的系统,然后马上升级到Windows7旗舰版,在安装SQL Server 2008 R2和Visual Studio 2010时遇到1406错误.尝试了很多方法,比如修改对应注册表的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6ZN3z.html" rel="bookmark" class="title">如何在LINQ To SQL中使用继承</a>
					<div>
						有的时候我们在设计数据库的时候发现如果完全把商务逻辑中的类影射到表中可能会照成数据库中很多表都很相似,甚至结构上都是一样的,下面举一个例子来说明如何处理这种情况.假设我们正在创建一个图书销售网站,但客 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRygwGb.html" rel="bookmark" class="title">Windows 8系统无法更新驱动的解决方法</a>
					<div>
						一.英伟达显驱文件修改(如果不是英伟达的驱动 可以省略这一步) 直接安装nvidia的驱动会出现以下错误 请右键计算机-管理-设备管理器 右键你的显卡-属性 点击硬件id 右键第二个-复制 然后进入你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQP4e8z.html" rel="bookmark" class="title">删除无法显示隐藏文件的病毒的方法</a>
					<div>
						  删除无法显示隐藏文件的病毒的方法: 选择&quot;显示隐藏文件&quot;这一选项后,发现U盘有个文件闪出来一下就马上又消失了,而再打开文件夹选项时,发现仍就是&quot;不显示隐藏文件&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M628wJM.html" rel="bookmark" class="title">PS在玻璃瓶上做出逼真的玻璃字体</a>
					<div>
						  1.打开玻璃瓶素材,打上&quot;52psxt&quot;字体,颜色随意,也可以在字体旁边拉一个好看的形状   2.给字体图层设置图层样式如下:           3.新建图层,放在字体图层下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOa3l5M.html" rel="bookmark" class="title">摄影后期高低频磨皮详解&plus;调色方式</a>
					<div>
						  摄影后期高低频磨皮详解+调色方式,简单粗暴思路及技巧,实用技能,值得借鉴学习 分类: PS入门教程 ps磨皮教程 ps后期处理教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZ2wvz.html" rel="bookmark" class="title">简单粗暴的三种方法打造照片朦胧感</a>
					<div>
						  简单粗暴的三种方法打造照片朦胧感,适用于小清新.森女系.梦境.复古等风格,非常有意思的摄影及后期,值得借鉴学习 分类: PS图片处理					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7vy9M.html" rel="bookmark" class="title">IntersectionObserver API 使用教程</a>
					<div>
						网页开发时,常常需要了解某个元素是否进入了&quot;视口&quot;(viewport),即用户能不能看到它. 上图的绿色方块不断滚动,顶部会提示它的可见性. 传统的实现方法是,监听到scroll事 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPO8vp.html" rel="bookmark" class="title">程序员专属健身操，大家一起动次打次浪起来！</a>
					<div>
						这次要分享给大家一套养生保健操,不仅能检测出身体的健康问题,同时还能起到锻炼的作用,这套操动作简单易行,可以坐着运动!适合所有的程序员和其它久坐的工作,程序员们可以边写程序边锻炼,更神奇的是,鱼和熊掌 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmVYAz.html" rel="bookmark" class="title">064&lowbar;《Delphi7程序设计与开发技术大全》</a>
					<div>
						&lt;Delphi7程序设计与开发技术大全&gt; Delphi 教程 系列书籍 (064) &lt;Delphi7程序设计与开发技术大全&gt; 网友(邦)整理 EMail: shuaihj@16 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKdj3b.html" rel="bookmark" class="title">盘点：2014 SNS开源软件动态</a>
					<div>
						问题描述 2014年,是SNS平台高速增长.甚至可以说是疯狂的一年,新技术层出不穷.巨头与新创企业竞争不断.资本大量涌入.以粉丝社区.用户社区.电商社区等为代表的SNS社区,以众多社交APP为代表的移 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAw63M.html" rel="bookmark" class="title">JSONObject jsonObject &equals; JSONObject&period;fromObject&lpar;&rpar;&semi;</a>
					<div>
						问题描述 JSONObject jsonObject = JSONObject.fromObject(); JSONObject jsonObject = JSONObject.fromObject( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AdqVz.html" rel="bookmark" class="title">ip 域名 dns-ip反查域名是怎么实现的</a>
					<div>
						问题描述 ip反查域名是怎么实现的 最近一直在研究IP反查域名,以前的帖子有的说是cn.bing出来,但我试了下,内容很少了.想知道那些网站的ip反查域名是怎么实现的.? 解决方案 其实还是DNS,只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAANkeM.html" rel="bookmark" class="title">CoreOS Fest 系列之第二篇： Systemd、Go、Calico、Sysdig</a>
					<div>
						本文讲的是CoreOS Fest 系列之第二篇: Systemd.Go.Calico.Sysdig,[编者的话]在 CoreOS Fest 第二天的会议中,演讲者展示了多个开源项目和工具,包括 Sys ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAGVwb.html" rel="bookmark" class="title">Kafka Zero-Copy 使用分析</a>
					<div>
						前言 Kafka 我个人感觉是性能优化的典范.而且使用Scala开发,代码写的也很漂亮的.重点我觉得有四个: NIO Zero Copy 磁盘顺序读写 Queue数据结构的极致使用 Zero-Copy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NPnmz.html" rel="bookmark" class="title">六大境外资产管理公司垄断外资银行QDII市场</a>
					<div>
						素有&quot;理财产品超市&quot;之称的外资银行,历来是中国投资者投资境外理财产品的重要渠道.然而,在林林总总光鲜亮丽的QDII产品的幕后推手,却是六家境外资产管理公司.从各大外资银行的公开信息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWr7dz.html" rel="bookmark" class="title">易凯CEO的人生创业论论调</a>
					<div>
						不一样的投资老总:易凯资本有限公司CEO王冉 王冉,易凯资本首席执行官,哈佛大学的经济学学士和哈佛商学院工商管理硕士.财富人生评价他为&quot;开博客,穿名牌,品美食,爱听流行歌曲的投行老总&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZJ8rb.html" rel="bookmark" class="title">详解AngularJS中&dollar;http缓存以及处理多个&dollar;http请求的方法&lowbar;AngularJS</a>
					<div>
						$http 是 AngularJS 中的一个核心服务,用于读取远程服务器的数据.在AngularJS的实际项目中,经常需要处理多个$http请求,每个$http请求返回一个promise,我们可以把多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk01XEz.html" rel="bookmark" class="title">python字符串格式化之学习笔记</a>
					<div>
						在python中格式化输出字符串使用的是%运算符,通用的形式为 •格式标记字符串 % 要输出的值组 其中,左边部分的&quot;格式标记字符串&quot;可以完全和c中的一致.右边的'值组'如果有两个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnyOvp.html" rel="bookmark" class="title">基础问题~</a>
					<div>
						问题描述 请问下~一个项目完成后~怎么才能够使目录里有.sln的解决方案呢~~比如说我看别人的源码我直接就能用解决方案打开就可以了~~而我自己的一个项目完成后没有.sln具体说说谢谢了 解决方案 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJO0YJb.html" rel="bookmark" class="title">程序探讨</a>
					<div>
						问题描述 学习C#好还是C++好?有没有编写打开,关闭图形控件的.net程序?十分感谢! 解决方案 解决方案二:需要哪个就学哪个解决方案三:建议都学解决方案四:都好解决方案五:都学最好是先学C++在学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLrRgM.html" rel="bookmark" class="title">請教一個關于DLLRegisterServer的問題</a>
					<div>
						问题描述 注册mswinsck控件,没有dllregisterserver输入点是怎么回事啊?我的開發工具是vb6.0+sql 解决方案 解决方案二:路过帮顶=============11月6日,论坛 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YAVap.html" rel="bookmark" class="title">datalist 怎么分页？</a>
					<div>
						问题描述 我现在已经把数据都查询出来了,只是都在一页上面,想把它分页,求详解,,,,,前台,后台代码!! 解决方案 解决方案二:试试AspNetPager:解决方案三:tryit:解决方案四:引用1楼 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
